﻿using System;
using System.Windows;
using System.Windows.Media.Imaging;

using DevExpress.Xpf.Bars;
using DevExpress.Xpf.Docking;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// DocumentPanel 3
        /// </summary>
        private DocumentPanel documentPanel3 = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Set DocumentPanel 1 바 버튼 항목 클릭시 처리하기 - setDocumentPanel1BarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// Set DocumentPanel 1 바 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void setDocumentPanel1BarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            ActivateItem(this.documentPanel1);

            this.documentPanel1.Content = new Uri(@"Source\SourceWindow1.xaml", UriKind.Relative);
        }

        #endregion
        #region Add DocumentPanel 3 바 버튼 항목 클릭시 처리하기 - addDocumentPanel3BarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// Add DocumentPanel 3 바 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void addDocumentPanel3BarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            if(this.documentPanel3 != null)
            {
                return;
            }

            this.documentPanel3 = this.dockLayoutManager.DockController.AddDocumentPanel
            (
                this.documentGroup,
                new Uri(@"Source\SourceUserControl3.xaml", UriKind.Relative)
            );

            this.documentPanel3.Caption = "DocumentPanel 3";

            DocumentPanel.SetMDILocation(this.documentPanel3, new Point(200, 200));
            DocumentPanel.SetMDISize(this.documentPanel3, new Size(400, 300));

            ActivateItem(this.documentPanel3);
        }

        #endregion
        #region Set DataContext For UserControl 바 버튼 항목 클릭시 처리하기 - setDataContextForUserControlBarButtonItem_ItemClick(sender, e)

        /// <summary>
        /// Set DataContext For UserControl 바 버튼 항목 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void setDataContextForUserControlBarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
        {
            if(this.documentPanel3 == null)
            {
                return;
            }

            Uri uri = new Uri("/Image/background.jpg", UriKind.Relative);

            ImageInformation imageInformation = new ImageInformation();

            imageInformation.Source      = new BitmapImage(uri);
            imageInformation.Description = uri.ToString();

            (this.documentPanel3.Control as SourceUserControl3).SetDataContext(imageInformation);

            ActivateItem(this.documentPanel3);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 항목 활성화 하기 - ActivateItem(baseLayoutItem)

        /// <summary>
        /// 항목 활성화 하기
        /// </summary>
        /// <param name="baseLayoutItem">BaseLayoutItem 객체</param>
        private void ActivateItem(BaseLayoutItem baseLayoutItem)
        {
            this.dockLayoutManager.LayoutController.Activate(baseLayoutItem);
        }

        #endregion
    }
}