﻿using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 소스 윈도우 2
    /// </summary>
    public partial class SourceWindow2 : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SourceWindow2()

        /// <summary>
        /// 생성자
        /// </summary>
        public SourceWindow2()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 왼쪽 버튼 클릭시 처리하기 - leftButton_Click(sender, e)

        /// <summary>
        /// 왼쪽 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void leftButton_Click(object sender, RoutedEventArgs e)
        {
            SetMargin(-10, 0);
        }

        #endregion
        #region 위쪽 버튼 클릭시 처리하기 - upButton_Click(sender, e)

        /// <summary>
        /// 위쪽 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void upButton_Click(object sender, RoutedEventArgs e)
        {
            SetMargin(0, -10);
        }

        #endregion
        #region 오른쪽 버튼 클릭시 처리하기 - rightButton_Click(sender, e)

        /// <summary>
        /// 오른쪽 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void rightButton_Click(object sender, RoutedEventArgs e)
        {
            SetMargin(10, 0);
        }

        #endregion
        #region 아래쪽 버튼 클릭시 처리하기 - downButton_Click(sender, e)

        /// <summary>
        /// 아래쪽 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void downButton_Click(object sender, RoutedEventArgs e)
        {
            SetMargin(0, 10);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 여백 설정하기 - SetMargin(leftOffset, topOffset)

        /// <summary>
        /// 여백 설정하기
        /// </summary>
        /// <param name="leftOffset">왼쪽 오프셋</param>
        /// <param name="topOffset">위쪽 오프셋</param>
        private void SetMargin(int leftOffset, int topOffset)
        {
            this.targetButton.Margin = new Thickness
            (
                targetButton.Margin.Left + leftOffset,
                targetButton.Margin.Top  + topOffset ,
                targetButton.Margin.Right            ,
                targetButton.Margin.Bottom
            );
        }

        #endregion
    }
}